/**
 @name dofold  
 
 The application {\em dofold} partitions the data in k-fold 
 where k is a user defined integer, according to the cross-validation technique.
 The that are subdivided in k fold and are generated test sets containing one fold of data and traininig sets
 containing the remeining k-1 folds of data; this procedure is repeated k times using each time a different
 fold as test set. The partition is performed through a random extraction of the data.\\
 
 
 {\bf Usage:} dofold datafile [options]\\
  
	datafile (string) : data file that must be subdivided in folds.\\  
  
 Options:
 
\begin{tabular}{ll} 
 -nf unsigned      &  number of the folds (default = 10) \\
 -na unsigned      &  number of attributes  (default = 2) \\
 -name string      &  name of the fold  files (without suffix). If omitted datafile is used instead.\\ 
 \end{tabular}
 
 {\bf Examples:} \\
 
 \begin{enumerate}
   \item {\em Generating 10 folds from the dataset data}: \\
	 {\tt dofold data} \\
	 It generates 20 data sets: 10 training set data.f1.train,...,data.f10.train and
	 10 test set data.f1.test,...,data.f10.test, assuming that data is a dataset with two attributes.
	 
	 \item {\em Generating 5 folds from the dataset data}: \\
	 {\tt dofold data -nf 5} \\
	 It generates 10 data sets: 5 training set data.f1.train,...,data.f5.train and
	 5 test set data.f1.test,...,data.f5.test\\
	 
	 \item {\em Generating 5 folds from the dataset newdata with  samples having 12 attributes}: \\
	 {\tt dofold data -nf 5 -na 12} \\
	 It generates 10 data sets: 5 training set newdata.f1.train,...,newdata.f5.train and
	 5 test set newdata.f1.test,...,newdata.f5.test\\
	 
	 \item {\em Generating 10 folds from the dataset data and storing them in files named mydata}: \\
	 {\tt dofold data -name mydata} \\
	 It generates 20 data sets: 10 training set mydata.f1.train,...,mydata.f10.train and
	 10 test set mydata.f1.test,...,mydata.f10.test.
	 
\end{enumerate}
 
 {\bf Output:}
 The applications outputs 2k files: k training sets namefile.f1.train, ..., namefile.fk.train and k
 test sets namefile.f1.test, ..., namefile.fk.test, where k is the number of the folds.
 
 @memo Application for the automatic construction of multiple folds of data.
*/
