/**
 @name nn  
 
 Permette di affrontare problemi di classificazione tramite l' applicazione diretta di un percettrone
 multistrato. 
 Sono selezionabili due tipi di percettrone multistrato (MLP), a seconda del tipo di codifica della classe
	di uscita:
	\begin{itemize}
	  \item OPC diretto, ovvero codifica one-per-class
		\item ECOC diretto. oveero codifica tramite codice a correzione d' errore generati tramite 
		  algoritmo BCH
	\end{itemize}
 Il percettrone multistrato  OPC ha tante uscite quante sono le classi da classificare
  e la dimensione dell' input deve essere uguale a quella dei pattern, mentre il MLP ECOC ha un numero 
	di uscite dipendente dalla lunghezza del codeword prescelta. Le opzioni del programma consentono di
 dimensionare e strutturare il MLP, di invocare diversi algoritmi di apprendimento e di impostare i
 parametri di learning. In input deve essere definiti il training set ed opzionalmente il test set (di
 default viene considerato come test set il training set stesso). Se non vengono impostate le opzioni,
 vengono considerate le opzioni di default.\\
 \\
 {\bf Uso:} nn trainfile [opzioni]\\
  
 Significato delle opzioni:
 \begin{verbatim}
 -test string      :  nome del file di testing
 -type string      :  tipo della rete
                      valori possibili:
											normal     (MLP normale)
											ecoc       (MLP ecoc)
 -lencw unsigned   :  lunghezza del codeword
 -nc unsigned      :  numero delle classi
 -nl unsigned      :  numero degli strati del MLP (default 2, puo' variare da 1 a 3)
 -h1 unsigned      :  numero unita' nascoste I strato 
 -h2 unsigned      :  numero unita' nascoste II strato (strato nascosto MLP a 2 strati)
 -d  unsigned      :  dimensione campioni/unita' di input
 -maxit unsigned   :  numero massimo iterazioni  (default 500)
 -maxerr double    :  errore massimo             (default 0.1, deve essere minore di 1)
 -alg (string)     :  tipo algoritmo di apprendimento 
                      valori possibili:
                    	gd         (gradient descent)
                    	gd_dl      (gradient descent linear decrement)
                    	gd_de      (gradient descent exponential decrement)
                    	md         (gradient descent with momentum)
                    	md_dl      (gradient descent with momentum and linear decrement)
                    	md_de      (gradient descent with momentum and exponential decrement)
                    	bold       (bold driver)
                    	boldmom    (bold driver with momentum)
 -mode (string)    :  modo di apprendimento: BYPATTERN O BYEPOCH 
                      valori possibili:
                      bypat      (by pattern)
                      byep       (by epoch)
 -rate (double)    :  tasso apprendimento (default 0.07)
 -mom (double)     :  valore del coefficiente del momento  (default 0.5)
 -incbold (double) :  valore incremento bold driver 
 -decbold (double) :  valore decremento bold driver
 -decr (double)    :  decremento gradiente/momento lineare o esponenziale 
 -s (string)       :  salva nel file i parametri della rete
 -out (string)     :  salva nel file l' output della rete
 -serr (string)    :  salva nel file gli errori di training della rete
 
 \end{verbatim}
 
 {\bf Output:}
 @see Output delle applicazioni classificatori MLP
 @see File di output dei MLP
 @see File della storia degli errori
 @see File per la memorizzazione del MLP
 
 @memo Applicazione per il training ed il test semplice di un percettrone multistrato.
*/
