/**
 @name subsampleLightData
 
 Application for resampling data.\\
 The application resamples with replacement a data set according to an uniform probability distribution.\\
 Data are in SVM-light format. If only one file is generated its name is specified by the the parameter basename.
 Otherwise, if more than one file has to be generated, basename is used as a common radix of all the generated files, and a
 progressive integer number is appended to basename. \\
 Use a seed diverse from 0 to generate the same seqience of random numbers, that is the same set of data. otherwise an
 unpredictable set of data is extracted from the data set.
 
 
 {\bf Usage:} subsampleLightData dataset basename nfiles ndata [seed]\\
 dataset is the dataset to be subsampled.\\
 Options:\\
\begin{tabular}{ll}
 dataset        & dataset from which data are randomly drawn\\ 
 basename       &  base name of the files to be generated\\
 nfiles       &  number of files to be generated \\
 ndata       &  number of data per file\\ 
 seed        &  random seed (def. 0). If seed=0 CPU time is used.\\
 \end{tabular}
 
 
 {\bf Examples:} \\
 
 \begin{enumerate}
	 
 \end{enumerate}
 
 {\bf Output:}\\
 One or more resampled data file.
 
 @memo Application to generate data randomly drawn from a data set in SVM-light format.
*/

