//  "McNemar.cc"
// December 2002
/**
  Application  implementing the lobag algorithm.\\
	SVMs are used as base learners. Itvprovides an out-of-bag estimate of the error for lobag
	ensemble of SVMs, using the exhaustive algorithm.

*/

#include<stdlib.h>
#include"utils.h"
#include"stattest.h"


static const int SIZE = 256;


/// file storing the predictions of the first classifier
char pred1[SIZE];

/// file storing the predictions of the second classifier
char pred2[SIZE];

/// file storing the correct predictions
char target[SIZE];


int doarg(char* arg[], int i);
void print_info_use(void);

////////////////////////////////////////////////////////
int main(int argc, char* argv[])
{
  /// level of confidence
  float level;
  
  if (argc != 4)
	  print_info_use();
  

  strcpy(pred1, argv[1]);
  strcpy(pred2, argv[2]);
  strcpy(target, argv[3]);
	
	 
	McNemar mc(pred1, pred2, target);
  bool res = mc.Reject_null(level);
  cout << "McNemars test results on " << pred1 << " and " << pred2 << ":" << endl;
  cout << "Pearson statistic : " << mc.get_gamma() << endl;
  if (res) 
    cout << "The null hypothesis is rejected with level of confidence equal to " << level << endl;
  else
    cout << "The null hypothesis cannot be rejected." << endl;		
  return 0;
}


void print_info_use(void)
{
  cerr << "
  McNemar.  NEURObjects 2.0 application implemeting the Mc Nemar's test.
  Usage:    McNemar pred1 pred2 target 
            pred1   file storing the predictions of the first classifier
            pred2   file storing the predictions of the second classifier
            target  file storing the correct predictions    
  " << endl;
  exit(1);
}

