// SNR_feature_sel.cc  2-9-2002 

#include<iostream.h>
#include<fstream.h>
#include<ctype.h>
#include<stdlib.h>
#include"utils.h"
#include"tset.h"
#include"matrix.h"
#include"snr.h"

static void print_info_use(void);

int main (int argc, char * argv[])
{
  int i;
	unsigned num_patt, num_attr, cl, num_perm;
	char dataset[128]; 
	char feature[128]; 
  float significance;

	
	if (argc != 8)
	  print_info_use();
	
	strcpy(dataset,argv[1]);
	strcpy(feature,argv[2]);
	cl = atoi(argv[3]);
	num_attr = atoi(argv[4]);
	num_patt = atoi(argv[5]);
	significance = atof(argv[6]);
	num_perm = atoi(argv[7]);
  
	
	SNRTest snr(num_attr, num_patt, dataset);
	
	snr.SNR_compute(cl);	
	//snr.SNR_print(cout); 
  snr.permutation_test(num_perm,cl);
	snr.select_features(significance);
	snr.save_feature_indices(feature);
  return 0;
}



void print_info_use(void)
{
  cerr << "
  SNR_feature_sel. NEURObjects application select features using the SNR correlation measure
  Usage: SNR_feature_sel dataset f_file cl nattr npatt signif n_perm
  dataset   source file 
  f_file    file where the selected feature indices will be stored
  cl        number of the class
  nattr     is the number of the attributes
  npatt     is the number of the patterns
  signif    significance
	n_perm    number of permutations
  " << endl;
  exit(1);
}
