// appl.h  

#ifndef APPL_H
#define APPL_H

#include<math.h>
#include<string.h>


#define GRADIENT_DESCENT                 0
#define GRADIENT_DESCENT_DECR_LIN        1
#define GRADIENT_DESCENT_DECR_EXP        2
#define MOMENTUM_DESCENT                 3
#define MOMENTUM_DESCENT_DECR_LIN        4
#define MOMENTUM_DESCENT_DECR_EXP        5
#define BOLD_DRIVER                      6
#define BOLD_DRIVER_MOMENTUM             7


#define BYPATT            0
#define BYEP              1


#define NORMAL            0
#define ECOC              1


#define OPC        0
#define PWC        1
#define CC         2
#define ECOC_ex    3
#define ECOC_BCH   4
#define DEC_FILE   5



extern const unsigned NCLASS;
extern const unsigned NFOLD;
extern const unsigned NATTR;   
extern const unsigned NLAYERS; 
extern const unsigned NHIDDEN1; 
extern const unsigned NHIDDEN2; 
extern const unsigned MAXITS; 
extern const double ERRTOL;
extern const unsigned LEARNTYPE;  
extern const unsigned LEARNMODE;  
extern const double ETA; 
extern const double ALPHA;  
extern const double INCR; 
extern const double DECR; 
extern const double DECRMOM;  
extern const char* SUBBASENAME;
extern const  unsigned NSAMPLES;
extern const unsigned NDATASETS;
extern const char SEPIN;
extern const char SEPOUT;


extern const unsigned NUMTYPE;

extern char* typenet[];


extern const unsigned NUMMODE;

extern char* modecode[];


extern const unsigned NUMALG;

extern char* algcode[];

                           

extern const unsigned NUMDEC;

extern char* deccode[];
                           

extern int Analyze_type(char* type);



extern int Analyze_mode(char* m);


extern int Analyze_alg(char* alg);


extern int Analyze_dec(char* scomp);


extern unsigned DoDefaultcw(unsigned const nclass);

#endif
