// binomial.cc
#include<math.h>
#include"binomial.h"
#include"utils.h"

double Binomial::fact (double n) {
  if (n==0) return 1;
	double res = 1;
	for (double i = 1; i<=n; i+=1)
	  res *= i;
	return res;
}

inline double Binomial::bincoeff (double n, double k) {
  return (fact(n)/(fact(k)*fact(n-k)));
}

inline double Binomial::probability (double n, double k, double p) {
  return (bincoeff(n,k) * pow(p,k) * pow(1.0-p,n-k));
}

double Binomial::cumulative (double n, double kstart, double kend, double p)  {
  if ((kstart>kend) || (kend > n) || (p<0) || (p>1))
	  error_exit("Binomial::cumulative : ", "incorrect parameters");
  double sum = 0;
	for (double k = kstart; k<=kend; k+=1)
	  sum += probability(n,k,p);
	return sum;
}
