//  "bs.cc"
// December 2002
/**
  Application  for sample bootstrapping.\\
	 It bootstrap samples from a given data set. It stores aldo the matrix of the out of bag points.
*/

#include<cstdlib>
#include"utils.h"
#include"bootstrapLight.h"

static unsigned const SIZE = 256;

static char dataset[SIZE];   
static char base[SIZE];  
static char bsmatrix[SIZE];
int n = 100;
int nsample = 50;
int seed = 0;  

 
static void print_info_use(void);

int doarg(char* arg[], int i);

////////////////////////////////////////////////////////
int main(int argc, char* argv[])
{
  	
  if ((argc < 4) || ((argc%2) == 1))
	  print_info_use();
  

  strcpy(dataset, argv[1]);
  strcpy(base, argv[2]);
  strcpy(bsmatrix, argv[3]);
	
	for (int i=4; i<argc; i+=2) 
     if (doarg(argv, i))
        print_info_use();
	
  
	BootstrapLight b(dataset, base, nsample, n, seed);
	b.save_m(bsmatrix);
	
  return 0;
}


void print_info_use(void)
{
  cerr << "
  bs. NEURObjects 2.0 application for bootstrapping samples from a given data set
  Usage:    bs dataset base bsmatrix [options]
            dataset      data set file
            base         base file name of botstrapped samples (base1, ..., basensample)
            bsmatrix     boostrap matrix file
  Options:
  -ns   integer  number of bootstrapped samples [def. 50]
  -n    integer  cardinality of bootstrapped samples [def. 100]
  -seed integer  random seed. If 0 clock time is used [def. 0]
  " << endl;
  exit(1);
}

int doarg(char* arg[], int i)  
{ 	
  if (!strcmp(arg[i], "-ns")) 
    nsample = atoi(arg[i+1]);
	else if (!strcmp(arg[i], "-n")) 
    n = atoi(arg[i+1]);
	else if (!strcmp(arg[i], "-seed")) 
    seed = atoi(arg[i+1]);
  else 
    return 1;
  return 0;
} 
