#include<iostream.h>
#include<fstream.h>
#include<ctype.h>
#include"utils.h"
#include"tset.h"

static void print_info_use(void);

int main (int argc, char * argv[])
{
  int i;
	unsigned num_train, num_attr;
	char suffix[8];
	char dataset1[128]; 
	char dataset2[128]; 
  char target[128]; 
  char sepin;
  char sepout;
	int is_normalized = 0;
 

	
	if (argc < 7)
	  print_info_use();
	
	strcpy(dataset1,argv[1]);
	strcpy(dataset2,argv[2]);
  strcpy(target,argv[3]);
	num_train = atoi(argv[4]);
	sepin = argv[5][0];
	if (!isprint(sepin)) error_exit("Separator must be a printable character");
	sepout = argv[6][0];
	if (!isprint(sepout)) error_exit("Separator must be a printable character");
	if (argc == 8) 
	  is_normalized = atoi(argv[7]); 
     
	num_attr = wc (dataset1); 
  TSetStrClass dataset(num_train, num_attr, dataset1, sepin, TrainingSet::noclass); 
  dataset.Transpose_data();
  dataset.load_target(target); 
  if (is_normalized)
	  dataset.normalize();
	// setting character separator
	dataset.set_sep(sepout);
	dataset.set_class_pos(TrainingSet::last);
	dataset.save(dataset2);
	
  return 0;
}



void print_info_use(void)
{
  cerr << "
  build_data_set. Application to transpose data
  Usage: convert_data_format dataset1 dataset2 target ntrain sep1 sep2 [norm] 
  dataset1 is the dataset to be converted
  dataset2 is the converted data set
  target   is the file of the targets
  ntrain   is the number of the examples
  sep1     is the separator character of  dataset1
  sep2     is the separator character of  dataset2
  norm     if = 1 normalization of data, = 0 no normalization (def.)
  " << endl;
  exit(1);
}
