// "bvdecomp.cc"
// November 2002


#include<ctype.h>
#include<stdlib.h>
#include<math.h>
#include<time.h>
#include<iostream.h>
#include<fstream.h>
#include"bvdecomp.h"
#include"utils.h"

BootstrapLight::BootstrapLight ( char* data, char* base, int nf, int n, int s = 0) {  
	dataset=data;	
	basename=base; 	
	nfiles=nf; 	
	ndata_sample=n;
	read_dataset(dataset);
	ndata = strings.size();
	seed = s;
	if (seed == 0)
	  seed = (int) time(NULL);
  srandom(seed);
	m = new (short*)[nfiles];
	for (int i=0; i<nfiles; i++) 
	  m[i] = new short[ndata];
	for (int i=0; i<nfiles; i++)
	  for (int j=0; j<ndata; j++)
		  m[i][j] = 1;
  write_bootstrap_samples(basename);
}

void BootstrapLight::read_dataset(char* dataset)  {
  
	ifstream ifs(dataset);
	if (!ifs)
	  error_exit("Cannot open file ", dataset);			
	// init random generator
	if (seed == 0)
	  seed = (int) time(NULL);
  srandom(seed);
	// read input file
	string line;
	getline(ifs,line); getline(ifs,line); 
	while (getline(ifs,line)) 
		 strings.push_back(line);
	if (ifs.bad())
	  error_exit("Error reading file ", dataset);
	ifs.close();
}



int BootstrapLight::unif_rand_generate(int min=0, int max=100)
{
  return (int)(min + ((float)random()/RAND_MAX) * max);
}



void BootstrapLight::write_bootstrap_samples(char* basename) {
  
	const int SIZE = 256;
	char bootstrap_sample[SIZE];
  ofstream ofs;
	ostrstream obasename(bootstrap_sample,SIZE,ios::out);
  for (int i = 1; i<=nfiles; i++) {
		  obasename.seekp(0,ios::beg);
			obasename << basename << i << ends;
			ofs.open(bootstrap_sample);
			if (!ofs)
	    	error_exit("Cannot open file ", bootstrap_sample); 
			// Heading
    	ofs << "# " << bootstrap_sample << " data file in SVM-light format." << endl;
    	ofs << "# Number of patterns: " << ndata_sample << endl;
			for (int j=0; j<ndata_sample; j++) {
		  	int k = unif_rand_generate(0, ndata);
				m[i-1][k] = 0;
				ofs << strings[k] << endl;
			}
			if (ofs.bad())
		  	error_exit("Error writing in ", bootstrap_sample);
			ofs.close(); 
	}
}


BootstrapLight::~BootstrapLight() {
  for (int i=0; i<nfiles; i++)
		delete [] m[i];
	delete [] m;
}





