//  "comp_spec_thresh"
// August 2004

/*
 
*/

#include<stdlib.h>
#include"vect.h"
#include"utils.h"


static unsigned const SIZE = 256;

static char file[SIZE];  




///////////////////////////////////  
static void print_info_use(void);


////////////////////////////////////////////////////////
int main(int argc, char* argv[])
{
	
  double buf = 0;
	double min_spec = 0;	
	double max_spec = 0;
	double avg_spec = 0;
	double min_t = 0;	
	double max_t = 0;
	double avg_t = 0;
	vect spec(10);
	vect t(10);
	
  if (argc < 2) 
     print_info_use();
 
		 
	strcpy(file, argv[1]);
	
		
	ifstream f(file);
  if (!f) error_exit("com_spec_thresh: Cannot open  file ", file);
	
	for (int i=0; i<10; i++) {
	  f >> buf;
		f >> spec[i];
		f >> buf;
		f >> t[i];	
	}
	min_spec = spec.min();  
  max_spec = spec.max(); 
  avg_spec = spec.avg(); 
  min_t = t.min(); 
  max_t = t.max(); 
  avg_t = t.avg();
	
	// print summary results on the last row:
	cout.precision(6);
  cout.setf(ios::left, ios::adjustfield);
	cout.width(12);  cout << avg_spec;
	cout.width(12);  cout << min_spec;
	cout.width(12);  cout << max_spec;
  cout.width(12);  cout << avg_t;
	cout.width(12);  cout << min_t;
	cout.width(12);  cout << max_t;
	cout.width(20);  cout << file << endl;

  return 0;
}


void print_info_use(void)
{
  cerr << "
  com_spec_thresh. Application for computing the avg min max of the specificity
                   and the threshold when sensitivity=1
  Usage: com_spec_thresh file
  file     :  file with the values corresponding to specificity, etc
  " << endl;
  exit(1);
}



