//  "computeblerr.cc"
/*
  
*/

#include<stdlib.h>
#include"utils.h"
#include <deque.h>

static const char* const BAR = "********************";
static char* const TRAIN = ".train";
static char* const TEST = ".test";
static const unsigned SIZE = 256;

static char basedatafile[SIZE];  
static char datafile[SIZE];

static void print_info_use(void);
static void compute_error (char* basedata,  char* const tt, int K, float & avg_error,float & stdev);

////////////////////////////////////////////////////////
int main(int argc, char* argv[])
{	
	int K;
	float average_test_error = 0;
	float average_train_error = 0;
  float stdev_test = 0;
	float stdev_train = 0;
	int dotrain = 1;
	 	
  if (argc < 3) 
     print_info_use();
 		 
	strcpy(basedatafile, argv[1]);
	K = atoi(argv[2]);
	
	if (argc == 4)
	   dotrain = atoi(argv[3]);
	
	if (dotrain)		
	  compute_error (basedatafile,  TRAIN, K, average_train_error, stdev_train);
	compute_error (basedatafile,  TEST, K, average_test_error, stdev_test);
		
	// print summary results on the last row:
  cout.setf(ios::left, ios::adjustfield);
  cout << endl << "Summary results:" << endl;
  cout.width(16);  cout << "Test error";
  cout.width(16);  cout << "St. dev.";
  cout.width(16);  cout << "Train error";
  cout.width(16);  cout << "St. dev." << endl;
	cout.width(16);  cout << average_test_error;
	cout.width(16);  cout << stdev_test;
	cout.width(16);  cout << average_train_error; 
	cout.width(16);  cout << stdev_train;
	cout.width(16);  cout << basedatafile << endl;
  return 0;
}

void compute_error (char* basedata,  char* const tt, int K, float & avg_error,float & stdev){
  float x;
	float sum_x = 0;
	float sum_x2 = 0;
	int num=0;
	ostrstream odata(datafile,256,ios::out);
	
	ifstream* ifs;
	for (int i=1; i<=K; i++) {	  
	  odata.seekp(0,ios::beg);
		odata << basedata <<  tt << i  << ".blerr" << ends;
    ifs = new ifstream(datafile);
    if (ifs==NULL)
	    error_exit("computeblerr : Can't open file ", datafile);	
		*ifs >> x;
		while (!ifs->eof()) {
		  num++;
			sum_x += x;
			sum_x2 += (x*x);
			*ifs >> x;	
		}
		if (ifs->bad())
	    error_exit("computeblerr : Error reading file ", datafile);
		delete ifs;
	}
  avg_error = sum_x/num;
	stdev = sqrt(sum_x2/num - (avg_error * avg_error));
}

		
	
	
	


void print_info_use(void)
{
  cerr << "
  computeblerr. Application for computing the average error and 
                the standard deviation error of the base learners.
  Usage: computeblerr datafile k [dotrain]
	datafile : base name of the file to be read
  k : number of files to be read
  dotrain : 1 (def.) compute also train error, 0 compute only test error
  The files to be read are datafile.train1, ... datafile.traink and
                           datafile.test1, ... datafile.testk." << endl;
  exit(1);
}

