// convert_data_format.cc  9-9-2001 

#include<iostream.h>
#include<fstream.h>
#include<ctype.h>
#include"utils.h"
#include"tset.h"

static void print_info_use(void);

int main (int argc, char * argv[])
{
  int i;
	unsigned num_train, num_attr;
	char suffix[8];
	char dataset1[128]; 
	char dataset2[128]; 
  char sepin;
  char sepout;
	int is_normalized = 0;

	
	if (argc < 6)
	  print_info_use();
	
	strcpy(dataset1,argv[1]);
	strcpy(dataset2,argv[2]);
	num_attr = atoi(argv[3]);
	sepin = argv[4][0];
	if (!isprint(sepin)) error_exit("Separator must be a printable character");
	sepout = argv[5][0];
	if (!isprint(sepout)) error_exit("Separator must be a printable character");
	if (argc == 7) 
	  is_normalized = atoi(argv[6]);
		
	num_train = wc (dataset1);  
  TrainingSet trainset(num_attr, num_train,  dataset1, sepin);
	if (is_normalized)
	  trainset.normalize();
	// setting character separator
	trainset.set_sep(sepout);
	trainset.save(dataset2);
	
  return 0;
}



void print_info_use(void)
{
  cerr << "
  convert_data_format. NEURObjects application to convert data format
  Usage: convert_data_format dataset1 dataset2 nattr sep1 sep2 [norm]
  dataset1 is the dataset to be converted
  dataset2 is the converted data set
  nattr    is the number of the attributes
  sep1     is the separator character of  dataset1
  sep2     is the separator character of  dataset2
  norm     if = 1 normalization of data, = 0 no normalization (def.)
  " << endl;
  exit(1);
}
