#!/bin/csh																																															  
# colon-rs-linear.sh 																																													  
# May 2004																																															  
# script for the experiments on the data set colon with random subspace enembles of SVMs
# using 5-fold cross-validation.																																	  

set basename="colon"	
set BASEDIRdata="~/EXP/RS-array/DATA/Colon-rs-data"	
set DIRresults="~/EXP/RS-array/Colon-rs/Results-linear"
set DIRresultsglobal="~/EXP/RS-array/Colon-rs/Results-global"
set DIRoutputfiles="~/EXP/RS-array/Colon-rs/Outputfiles"
set resglobal=${basename}-rs-linear.cv
set LOGFILE="colon-rs-linear.log"
set kernel=0
set nbaselearner=200
set nfolds=5
# set CValues="0.01 0.1 0.5 1 5 10 50 100 500 1000"	
#  set RSValues="2 4 8 16 32 64 128 256 512 1024"			
set CValues="0.01 0.1 0.5 1 5 10 50 100 500 1000" 
set RSValues="2 4 8 16 32 64 128 256 512 1024"     																																												 

if (!(-e ${DIRresults})) mkdir ${DIRresults}
if (!(-e ${DIRresultsglobal})) mkdir ${DIRresultsglobal}
if (!(-e ${DIRoutputfiles})) mkdir ${DIRoutputfiles}

hostname > ${LOGFILE}
echo "Start at: " >> ${LOGFILE}
date >> ${LOGFILE}

if (-e ${DIRresultsglobal}/${resglobal}) rm -f ${DIRresultsglobal}/${resglobal}

foreach RS ($RSValues)
  foreach C ($CValues)
    set base=${basename}-rs${RS}-c${C}
    set resultfile=${base}.cv 
    set DIRdata=${BASEDIRdata}-$RS 
    rssvm_cv ${DIRdata}/${basename} -type ${kernel} -nb ${nbaselearner} -subdim ${RS} -k ${nfolds} \
    -c $C -sbtest 1 -sbtrain 1 -setrain 1 -setest 1 -train 1 -p 0 \
    -pred ${DIRoutputfiles}/${base}.test -predtrain ${DIRoutputfiles}/${base}.train \
    > ${DIRresults}/${resultfile}   
    set row=`tail -n 1 ${DIRresults}/${resultfile}` 
    set row="${row}    ${base}" 
      echo ${row} >> ${DIRresultsglobal}/${resglobal}																																								 
  end
end

rm -f basres*  model*
echo "End at:" >> ${LOGFILE}
date >> ${LOGFILE}

