#!/bin/csh																																															  
# colon-svm-linear.sh 																																													  
# May 2004																																															  
# script for the experiments on the data set colon with single linear SVM
# using 5-fold cross-validation.																																	  

set basename="colon"	
set DIRdata="~/EXP/RS-array/DATA/Colon-light"	
set DIRresults="~/EXP/RS-array/Colon-svm/Results-linear"
set DIRresultsglobal="~/EXP/RS-array/Colon-svm/Results-global"
set resglobal=${basename}-svm-linear.cv
set LOGFILE="colon-svm-linear.log"
set kernel=0
set CValues="0.01 0.1 0.5 1 5 10 50 100 500 1000"																																																 

if (!(-e ${DIRresults})) mkdir ${DIRresults}
if (!(-e ${DIRresultsglobal})) mkdir ${DIRresultsglobal}

hostname > ${LOGFILE}
echo "Start at: " >> ${LOGFILE}
date >> ${LOGFILE}

if (-e ${DIRresultsglobal}/${resglobal}) rm -f ${DIRresultsglobal}/${resglobal}

foreach C ($CValues)
  set resultfile=${basename}-svm-c$C.cv 
  svm_cv ${DIRdata}/${basename} -type ${kernel} -k 5	-c $C	-p 0 > 	${DIRresults}/${resultfile}								
  set row=`tail -n 1 ${DIRresults}/${resultfile}` 
  set row="${row}    ${basename}-svm-c$C" 
   echo ${row} >> ${DIRresultsglobal}/${resglobal}																											 
end

rm -f pred*
echo "End at:" >> ${LOGFILE}
date >> ${LOGFILE}

