#!/bin/csh
# doblerr-gaussian.sh
# May 2004
# script for computing the average error and stdev of the gaussian base learners

if ( $#argv != 0) then
    echo "doblerr-gaussian.sh: script for   computing the average error and stdev of the base learners"
	  echo "Usage: doblerr-gaussian.sh"
		exit		
endif

set basename="colon"
set DIRoutputfiles="~/EXP/RS-array/Colon-rs-gaussian/Outputfiles-gaussian"
set DIRresultsglobal="~/EXP/RS-array/Colon-rs-gaussian/Results-global" 
set resultfile="rs-single-base-gaussian"   

# number of folds
set K=5

set RSValues="2 4 8 16 32 64 128 256 512 1024"  
set SigmaValues="0.1 0.2 0.5 1 5 10 20 50 100 200 500 1000" 
set CValues="0.01 0.1 1 10 50 100 500 1000"	

if (-e ${DIRresultsglobal}/${resglobal}) rm -f ${DIRresultsglobal}/${resultfile}

foreach RS ($RSValues)
  foreach S ($SigmaValues)
    foreach C ($CValues)                                                                              
    set base=${basename}-rs${RS}-s${S}-c${C}                                                                                                                                
    set name=${DIRoutputfiles}/${base}                                                                 
    computeblerr ${name} $K | tail -n 1 >>   ${DIRresultsglobal}/${resultfile}  
		end
	end                                                                                                       
end	

echo FINITO.
