#!/bin/csh
# doblerr-linear.sh
# May 2004
# script for computing the average error and stdev of the linear base learners

if ( $#argv != 0) then
    echo "doblerr-linear.sh: script for   computing the average error and stdev of the base learners"
	  echo "Usage: doblerr-linear.sh"
		exit		
endif

set basename="colon"
set DIRlinear="~/EXP/RS-array/Colon-rs/Outputfiles-linear"
set DIRresultsglobal="~/EXP/RS-array/Colon-rs/Results-global" 
set resultfile="rs-single-base-linear"   

# number of folds
set K=5

set RSValues="2 4 8 16 32 64 128 256 512 1024"  

set CValues="0.1 1 10 50 100 500 1000"	

if (-e ${DIRresultsglobal}/${resglobal}) rm -f ${DIRresultsglobal}/${resultfile}

foreach RS ($RSValues)
  foreach C ($CValues)                                                                                
  set base=${basename}-rs${RS}-c${C}                                                                                                                                  
  set name=${DIRlinear}/${base}                                                                   
  computeblerr ${name} $K | tail -n 1 >>   ${DIRresultsglobal}/${resultfile}   
	end                                                                                                      
end	

echo FINITO.
