#!/bin/csh
# doblerr-poly.sh
# May 2004
# script for computing the average error and stdev of the poly base learners

if ( $#argv != 0) then
    echo "doblerr-poly.sh: script for   computing the average error and stdev of the base learners"
	  echo "Usage: doblerr-poly.sh"
		exit		
endif

set basename="colon"
set DIRoutputfiles="~/EXP/RS-array/Colon-rs-poly/Outputfiles-poly"
set DIRresultsglobal="~/EXP/RS-array/Colon-rs-poly/Results-global" 
set resultfile="rs-single-base-poly"   

# number of folds
set K=5

set RSValues="2 4 8 16 32 64 128 256 512 1024"  
set DValues="1 2 3 4 5 6 7 8 9"  
set CValues="0.01 0.1 1 10 50 100 500 1000"	

if (-e ${DIRresultsglobal}/${resglobal}) rm -f ${DIRresultsglobal}/${resultfile}

foreach RS ($RSValues)
  foreach D ($DValues)
    foreach C ($CValues)                                                                              
    set base=${basename}-rs${RS}-d${D}-c${C}                                                                                                                                
    set name=${DIRoutputfiles}/${base}                                                                 
    computeblerr ${name} $K | tail -n 1 >>   ${DIRresultsglobal}/${resultfile}  
		end
	end                                                                                                       
end	

echo FINITO.
