#!/bin/csh
# doblerr.sh
# May 2004
# script for computing the average error and stdev of the base learners

if ( $#argv != 0) then
    echo "doblerr.sh: script for   computing the average error and stdev of the base learners"
	  echo "Usage: doblerr.sh"
		exit		
endif

set basename="colon"
set DIRlinear="~/EXP/RS-array/Colon-rs/Outputfiles-linear"
set DIRpoly="~/EXP/RS-array/Colon-rs-poly/Outputfiles-poly"
set DIRgaussian="~/EXP/RS-array/Colon-rs-gaussian/Outputfiles-gaussian"
# directory where the folds for the single SVMs will be stored
set SVMlightdir="~/EXP/RS-array/DATA/Colon-light"
# directory where the folds for the random subspace ensembles of SVMs will be stored
set RSdir="~/EXP/RS-array/DATA/Colon-rs-data"
# dimension of the input data
set dim=2000
# number of folds
set nfolds=5
# number of samples e.g. of the base learners
set nsample=200

set RSValues="2 4 8 16 32 64 128 256 512 1024"  

dolightfold.sh ${basename} ${SVMlightdir} $dim $nfolds

dorsfold.sh ${basename} ${RSdir} $dim $nfolds $nsample "${RSValues}"

