#!/bin/csh
# docolondata.sh
# May 2004
# script for the automatic generation of all the data for the random subspace experiments on the colon data set.
# Note that the folds must be in the directory where this script will be launched

if ( $#argv != 0) then
    echo "docolondata.sh: script for the automatic generation of all the data for the random subspace experiments on the colon data set." 
	  echo "Usage: docolondata.sh"
		exit		
endif

set basename="colon"
# directory where the folds for the single SVMs will be stored
set SVMlightdir="~/EXP/RS-array/DATA/Colon-light"
# directory where the folds for the random subspace ensembles of SVMs will be stored
set RSdir="~/EXP/RS-array/DATA/Colon-rs-data"
# dimension of the input data
set dim=2000
# number of folds
set nfolds=5
# number of samples e.g. of the base learners
set nsample=200

set RSValues="2 4 8 16 32 64 128 256 512 1024"  

dolightfold.sh ${basename} ${SVMlightdir} $dim $nfolds

dorsfold.sh ${basename} ${RSdir} $dim $nfolds $nsample "${RSValues}"

