#!/bin/csh
# doexpdata.sh
# May 2004
# script for the automatic generation of all the data for the random subspace experiments
# note that the folds must be in the directory where this script will be launched

if ( $#argv != 1) then
    echo "doexpdata.sh: script for the automatic generation of all the data for the random subspace experiments" 
	  echo "Usage: doexpdata.sh data"
    echo "data : base name of the file in NO format"
		exit		
endif

set basename=$1
# directory where the folds for the single SVMs will be stored
set SVMlightdir="~/EXP/RS-array/DATA/Colon-light"
# directory where the folds for the random subspace ensembles of SVMs will be stored
set RSdir="~/EXP/RS-array/DATA/Colon-rs-data"
# dimension of the input data
set dim=2000
# number of folds
set nfolds=5
# number of samples e.g. of the base learners
set nsample=200

set subdimvalues="2 3 4"

dolightfold.sh ${basename} ${SVMlightdir} $dim $nfolds

dorsfold.sh ${basename} ${RSdir} $dim $nfolds $nsample "$subdimvalues"

