#!/bin/csh
# dolightfold.sh
# May 2004
# script for the automatic translation of a set of cv file in NEURObjects (NO) format into SVMlight format
# Usage: dolightfold.sh data destinationdir dim nfold
# data : base name of the file in NO format
# destinationdir : directory where the correponfing svmlight data will be stored
# nfold : number of folds

if ( $#argv != 4) then
    echo "dolightfold.sh: script for the automatic translation" 
		echo "of a set of cv file in NEURObjects (NO) format into SVMlight format"
	  echo "Usage: dolightfold.sh data destinationdir dim nfold"
    echo "data : base name of the file in NO format"
		echo "destinationdir : directory where the correponfing svmlight data will be stored"
		echo "dim : dimension of the data"
		echo "nfold : number of folds"
		exit		
endif

set BASE=$1
set DIR=$2
set dim=$3
set n=$4
if (!(-e $DIR)) mkdir $DIR


set i=1
while ( $i <= $n )
  set NOfile=${BASE}.f$i.train
	set lightfile=${DIR}/${NOfile}
  NO2light  ${NOfile} $lightfile -d $dim
	set NOfile=${BASE}.f$i.test
	set lightfile=${DIR}/${NOfile}
  NO2light  ${NOfile} $lightfile -d $dim
	@ i = $i + 1
end
