#!/bin/csh																																															  
# dorsfold.sh 																																													  
# May 2004																																															  
# script for the automatic generation of a set of cv file in SVMlight format for random subspace ensemble 
# Usage: dorsfold.sh data destinationdir dim nfold																											  
# data : base name of the file in NO format 																														  
# destinationdir : directory where the correponfing svmlight data will be stored												  
# dim : dimension of the input data 																																		  
# nfold : number of folds 																																							  
# nsample : number of samples 																																					  


if ( $#argv != 6) then																																												 
    echo "dolightfold.sh: script for the automatic translation"                                                
    echo "of a set of cv file in NEURObjects (NO) format into SVMlight format"																 
    echo "Usage: dolightfold.sh data destinationdir dim nfold nsample"																				 
    echo "data : base name of the file in NO format"                                                           
    echo "destinationdir : base directory where the correponding svmlight data will be stored" 										 
    echo "dim : dimension of the input data"																																	 
    echo "nfold : number of folds"																																						 
    echo "nsample : number of samples"
		echo "subdimvalues : list of the dimensions of the random subspace to be generated"																																				 
    exit    																																																	 
endif 																																																				 


set BASE=$1                                                                                                    
set DIR=$2																																																		 
set dim=$3																																																		 
set nfold=$4																																																	 
set nsample=$5
set subdimvalues="$6"																																																 

foreach subdim ($subdimvalues)																																								 
  set i=1 																																																		 
  while ( $i <= $nfold )																																													 
    set NOfiletrain=${BASE}.f$i.train    
		set npattern=`wc -l < ${NOfiletrain}`                                                                      
    make_rs_data ${NOfiletrain} -dim $dim -subdim $subdim -npattern $npattern -nfiles $nsample -format 2  													 
    set NOfiletest=${BASE}.f$i.test 
		cp ${NOfiletrain}.index ${NOfiletest}.index		
		set npattern=`wc -l < ${NOfiletest}`																																			 
    make_rs_data ${NOfiletest} -dim $dim -subdim $subdim -npattern $npattern -nfiles $nsample -format 2 -index ${NOfiletrain}.index  
    @ i = $i + 1																																															 
  end 																																																				 
  set SUBDIR=${DIR}-$subdim																																													 
   if (!(-e $SUBDIR)) mkdir $SUBDIR																																									 
  mv ${BASE}.f*.train?* $SUBDIR																																									 
  mv ${BASE}.f*.test?* $SUBDIR                                                                                                                                                                  
end 																																																					 


