// ecocnet.h

#ifndef ECOCNET_H
#define ECOCNET_H

#include<iostream.h>
#include<queue>
#include"act_fun.h"
#include"utils.h"
#include"layer.h"
#include"tset.h"
#include"learn.h"
#include"decomp.h"
#include"net.h"
#include"matrix.h"
  
  // suffix output
  static const char EOUT_EXT[] = ".eout";

/**
  Error Correcting Output Coding simple perceptron.\\
	@memo ECOC perceptron - HTML documentation under construction.
*/  
class OneLayerECOC : public OneLayer {

private:
 
  d_ECOC_BCH* scomp;
  
  
public:
  
  OneLayerECOC() {n_inputs = 0; n_outputs = 0;}
	
  OneLayerECOC(unsigned nclass, unsigned nin, unsigned length, act_func fout=sigmoid);
  
	~OneLayerECOC() {}
  
  void read_weigths(char* namefile){}
	
	  
	void save_weights(char* namefile) {}
	
  void save_out(TrainingSet& tset, char* file);
 
  	
		
protected:
 
  void Init_C(void);  // inizializza la matrice di codifica one-per-class
	
	
      
};



/**
  Error Correcting Output Coding MLP with one hidden layer.\\
	@memo ECOC Two-Layer MLP - HTML documentation under construction.
*/  
class TwoLayerECOC : public OneLayerECOC {

public:
  TwoLayerECOC() {n_hidden1 = 0; n_layers = 2;}
  
	
	TwoLayerECOC(unsigned nclass, unsigned nhidden, unsigned nin, unsigned length,
	              act_func fout=sigmoid, act_func fhid1=sigmoid);
  
	~TwoLayerECOC() {}
  
	
  inline unsigned Nhidden1() const {return n_hidden1;} 
	
  void init_weights_norm(int seed = 0);
	
  void init_weights_const(double x); 
	
  void print_weights(void);  
	
  vect& compute (vect& vinput);  
  
  void backprop(vect& t, vect& x); 
	
  void print_info_grad(void);   
  
  void save_weights(char* namefile) {}  
  
protected:
  
	unsigned n_hidden1;
  
};


/**
  Error Correcting Output Coding MLP with two hidden layers.\\
	@memo ECOC Three-Layer MLP -  HTML documentation under construction.
*/  
class ThreeLayerECOC : public TwoLayerECOC {

public:
  ThreeLayerECOC() {n_hidden2 = 0; n_layers = 3;}
	
	
  ThreeLayerECOC(unsigned nclass, unsigned nhidden1, unsigned nhidden2, unsigned nin, unsigned length,
                       act_func fout=sigmoid, act_func fhid1=sigmoid, act_func fhid2=sigmoid);
  
	~ThreeLayerECOC() {}
  
	
  void init_weights_norm(int seed = 0); 
	
  void init_weights_const(double x); 
	
  void print_weights(void);  
	
  vect& compute (vect& vinput);  
  
	
  void backprop(vect& t, vect& x); 
	
  void print_info_grad(void);   
  
	
  void save_weights(char* namefile) {}  
 
protected:
 
	unsigned n_hidden2;
  
};






#endif
