// partitionLightData.cc  Dec 2003

#include<iostream>
#include<fstream>
#include<string>
#include<strstream>
#include<vector>
#include<ctime>
#include<cstdlib>
#include"utils.h"

using namespace std;

static void print_info_use(void);


int main (int argc, char * argv[]){
  
	const int SIZE = 256;
	char basename[SIZE];
	int cl; 
	
	
	if (argc < 5)
	  print_info_use();
	
	int nfiles = atoi(argv[3]);	
	int ndata = atoi(argv[4]);	

	
	ifstream ifs(argv[1]);
	if (!ifs)
	  error_exit("Cannot open file ", argv[1]);		
	ofstream ofs;
	ostrstream obasename(basename,SIZE,ios::out);
	vector<string> strings;	
	// read input file
	string line;
  // it discards the first two lines
	getline(ifs,line); getline(ifs,line); 
	while (getline(ifs,line)) 
		 strings.push_back(line);
	if (ifs.bad())
	  error_exit("Error reading file ", argv[1]);
	ifs.close();
		 
	int maxline = strings.size();
	
	if ((nfiles*ndata) > maxline) 
	  error_exit("Cannot generate partition");
		
	int k = 0;	 
	  for (int i = 1; i<=nfiles; i++) {
		  obasename.seekp(0,ios::beg);
			obasename << argv[2] << i << ends;
			ofs.open(basename);
			if (!ofs)
	    	error_exit("Cannot open file ", basename); 
			// Heading
    	ofs << "# " << basename << " data file in SVM-light format." << endl;
    	ofs << "# Number of patterns: " << ndata << endl;
			for (int j=0; j<ndata; j++) {
				ofs << strings[k++] << endl;
			}
			if (ofs.bad())
		  	error_exit("Error writing in ", basename);
			ofs.close(); 
		}  		
	
	
  return 0;
}


void print_info_use(void)
{
  cerr << "
  subsampleLightData. NEURObjects application to partition data
	                    drawn from a data set in SVM-light format.
  Usage: partitionLightData dataset basename nfiles ndata 
         dataset   : dataset from which data are drawn
         basename  : base name of the files to be generated
         nfiles    : number of files to be generated
         ndata     : number of data per file
  " << endl;
  exit(1);
}
