// splitLightData.cc  June 2004


#include<iostream>
#include<fstream>
#include<string>
#include<strstream>
#include<vector>
#include<ctime>
#include<cstdlib>
#include"utils.h"

using namespace std;

static void print_info_use(void);

int unif_rand_generate(int min, int max);

int main (int argc, char * argv[]){
  
	const int SIZE = 256;
	char basename[SIZE];
	int cl; 
	int seed = 0;
	int k;
	
	if (argc < 5)
	  print_info_use();
	
	int nsplits = atoi(argv[3]);	
	float perc = atof(argv[4]);	
	if (argc == 6)
	  seed = atoi(argv[5]);
	
	ifstream ifs(argv[1]);
	if (!ifs)
	  error_exit("Cannot open file ", argv[1]);		
	ofstream ofs;
	ostrstream obasename(basename,SIZE,ios::out);
	vector<string> strings;
	// init random generator
	if (seed == 0)
	  seed = (int) time(NULL);
  srandom(seed);
	// read input file
	string line;
  // it discards the first two lines
	getline(ifs,line); getline(ifs,line); 
	while (getline(ifs,line)) 
		 strings.push_back(line);
	if (ifs.bad())
	  error_exit("Error reading file ", argv[1]);
	ifs.close();
		 
	int maxline = strings.size();
	int ndata= (int) (maxline*perc);
	vector<bool> v(maxline);
	
		 
	if (nsplits == 1) {
	  obasename.seekp(0,ios::beg);
		obasename << argv[2] << ".train" << ends;
		ofs.open(basename);
		if (!ofs)
	    error_exit("Cannot open file ", basename); 
		// Heading
    ofs << "# " << basename << " data file in SVM-light format." << endl;
    ofs << "# Number of patterns: " << ndata << endl;
		for (int q=0; q<maxline; q++)
	    v[q] = false;
		for (int j=0; j<ndata; j++) {
		  do {
		       k = unif_rand_generate(0, maxline);
			} while (v[k] == true);
			v[k] = true;
			ofs << strings[k] << endl;
		}
		if (ofs.bad())
		  error_exit("Error writing in ", basename); 
		ofs.close();
		obasename.seekp(0,ios::beg);  
		obasename << argv[2] << ".test" << ends;
		ofs.open(basename);
		if (!ofs)
	    error_exit("Cannot open file ", basename); 
		// Heading
    ofs << "# " << basename << " data file in SVM-light format." << endl;
    ofs << "# Number of patterns: " << maxline-ndata << endl;
		for (int j=0; j<maxline; j++) {
		  if (v[j] == false) 
			  ofs << strings[j] << endl;
		}
		if (ofs.bad())
		  error_exit("Error writing in ", basename);   						
	}
	else {
	  for (int i = 1; i<=nsplits; i++) {
		  obasename.seekp(0,ios::beg);
			obasename << argv[2] << ".f" << i << ".train" << ends;
			ofs.open(basename);
			if (!ofs)
	    	error_exit("Cannot open file ", basename); 
			// Heading
    	ofs << "# " << basename << " data file in SVM-light format." << endl;
    	ofs << "# Number of patterns: " << ndata << endl;
			for (int q=0; q<maxline; q++)
	      v[q] = false;
			for (int j=0; j<ndata; j++) {
		  	do {
		         k = unif_rand_generate(0, maxline);
			  } while (v[k] == true);
			  v[k] = true;
				ofs << strings[k] << endl;
			}
			if (ofs.bad())
		  	error_exit("Error writing in ", basename);
			ofs.close(); 
			obasename.seekp(0,ios::beg);
			obasename << argv[2] << ".f" << i << ".test" << ends;
			ofs.open(basename);
			if (!ofs)
	    	error_exit("Cannot open file ", basename); 
			// Heading
    	ofs << "# " << basename << " data file in SVM-light format." << endl;
    	ofs << "# Number of patterns: " << maxline-ndata << endl;
			for (int j=0; j<maxline; j++) {
		  if (v[j] == false) 
			  ofs << strings[j] << endl;
		  }
		  if (ofs.bad())
		    error_exit("Error writing in ", basename); 
			ofs.close();
		}  		
	}
	
  return 0;
}

int unif_rand_generate(int min=0, int max=100)
{
  return (int)(min + ((float)random()/RAND_MAX) * max);
}

void print_info_use(void)
{
  cerr << "
  splitLightData. NEURObjects application to split data in SVM-light format.
  Usage: splitLightData dataset basename nsplits perc [seed]
         dataset   : dataset from which data are splitted
         basename  : base name of the files to be generated
         nsplits   : number of splits to be generated
         perc      : percentual of the data held for the traininig set [0,1]
         seed      : random seed (def. 0). If seed=0 CPU time is used.
  " << endl;
  exit(1);
}
