// subsampleLightData.cc  June 2002

#include<iostream>
#include<fstream>
#include<string>
#include<strstream>
#include<vector>
#include<ctime>
#include<cstdlib>
#include"utils.h"

using namespace std;

static void print_info_use(void);

int unif_rand_generate(int min, int max);

int main (int argc, char * argv[]){
  
	const int SIZE = 256;
	char basename[SIZE];
	int cl; 
	int seed = 0;
	
	if (argc < 5)
	  print_info_use();
	
	int nfiles = atoi(argv[3]);	
	int ndata = atoi(argv[4]);	
	if (argc == 6)
	  seed = atoi(argv[5]);
	
	ifstream ifs(argv[1]);
	if (!ifs)
	  error_exit("Cannot open file ", argv[1]);		
	ofstream ofs;
	ostrstream obasename(basename,SIZE,ios::out);
	vector<string> strings;
	// init random generator
	if (seed == 0)
	  seed = (int) time(NULL);
  srandom(seed);
	// read input file
	string line;
  // it discards the first two lines
	getline(ifs,line); getline(ifs,line); 
	while (getline(ifs,line)) 
		 strings.push_back(line);
	if (ifs.bad())
	  error_exit("Error reading file ", argv[1]);
	ifs.close();
		 
	int maxline = strings.size();
	
		 
	if (nfiles == 1) {
	  obasename << argv[2] << ends;
		ofs.open(basename);
		if (!ofs)
	    error_exit("Cannot open file ", basename); 
		// Heading
    ofs << "# " << basename << " data file in SVM-light format." << endl;
    ofs << "# Number of patterns: " << ndata << endl;
		for (int j=0; j<ndata; j++) {
		  int k = unif_rand_generate(0, maxline);
			ofs << strings[k] << endl;
		}
		if (ofs.bad())
		  error_exit("Error writing in ", basename);   		
	}
	else {
	  for (int i = 1; i<=nfiles; i++) {
		  obasename.seekp(0,ios::beg);
			obasename << argv[2] << i << ends;
			ofs.open(basename);
			if (!ofs)
	    	error_exit("Cannot open file ", basename); 
			// Heading
    	ofs << "# " << basename << " data file in SVM-light format." << endl;
    	ofs << "# Number of patterns: " << ndata << endl;
			for (int j=0; j<ndata; j++) {
		  	int k = unif_rand_generate(0, maxline);
				ofs << strings[k] << endl;
			}
			if (ofs.bad())
		  	error_exit("Error writing in ", basename);
			ofs.close(); 
		}  		
	}
	
  return 0;
}

int unif_rand_generate(int min=0, int max=100)
{
  return (int)(min + ((float)random()/RAND_MAX) * max);
}

void print_info_use(void)
{
  cerr << "
  subsampleLightData. NEURObjects application to generate data
	                    drawn randomly from a data set in SVM-light format.
  Usage: subsampleLightData dataset basename nfiles ndata [seed]
         dataset   : dataset from which data are randomly drawn
         basename  : base name of the files to be generated
         nfiles    : number of files to be generated
         ndata     : number of data per file
         seed      : random seed (def. 0). If seed=0 CPU time is used.
  " << endl;
  exit(1);
}
