// variation_filter.cc May 2004

#include<iostream.h>
#include<fstream.h>
#include<ctype.h>
#include<deque.h>
#include"utils.h"
#include"tset.h"
#include"matrix.h"

static void print_info_use(void);
static void save_filtered_genes(deque <unsigned> & filtered_genes, char* filename);

int main (int argc, char * argv[])
{
  int i;
	unsigned num_train, num_attr;
	char dataset1[128]; 
	char dataset2[128]; 
  float fold_tresh, abs_tresh;
	int is_normalized = 0;
  deque <unsigned> filtered_genes;
	
	if (argc < 6)
	  print_info_use();
	
	strcpy(dataset1,argv[1]);
	strcpy(dataset2,argv[2]);
	num_attr = atoi(argv[3]);
	fold_tresh = atof(argv[4]);
  abs_tresh = atof(argv[5]);
	if (argc == 7) 
	  is_normalized = atoi(argv[6]);
		
	num_train = wc (dataset1);  
  TrainingSet trainset(num_attr, num_train,  dataset1, ',', TrainingSet::noclass);
  TrainingSet* tset = trainset.absolute_fold_filter(abs_tresh, fold_tresh, filtered_genes);
	if (is_normalized)
	  tset->normalize_var();
	tset->save(dataset2);
	save_filtered_genes(filtered_genes, dataset2);
	delete tset;
	
	
	
  return 0;
}


void save_filtered_genes(deque <unsigned> & filtered_genes, char* filename) {
  
	unsigned const SIZE = 256;
	char buf[SIZE];
	ostrstream ofiltered(buf,SIZE,ios::out);
	ofiltered << filename << ".filtered_genes" << ends;
  
	ofstream of(buf);
	if (!of)
	  error_exit("save_filtered_genes : Can't open file ", buf);
	unsigned num_filtered = filtered_genes.size();
	of << "Number of filtered genes = " << num_filtered << endl;
  for (unsigned i = 0; i < num_filtered; i++)
	  of << filtered_genes[i] << endl;
	if (of.bad())
	  error_exit("save_filtered_genes :  : Error writing file ", buf);
}

void print_info_use(void)
{
  cerr << "
  variation_filter. NEURObjects application for  filtering genes 
  Usage: variation_filter dataset1 dataset2 nattr fold_tresh abs_tresh [norm]
  dataset1   is the raw dataset 
  dataset2   is the filtered data set
  nattr      is the number of the attributes
  fold_tresh  is the fold threshold
  abs_tresh   is the absolute threshold
  norm     if = 1 normalization of data, = 0 no normalization (def.)
  " << endl;
  exit(1);
}
